# RewardControlStorage.sol

View Source: [contracts/RewardControlStorage.sol](https://github.com/AlkemiNetwork/alkemi-earn-contracts/tree/ae6d5c01ff8b3810c4005457ac7ce441ab1c7ec5/contracts/RewardControlStorage.sol)

**↘ Derived Contracts:** [**RewardControl**](/earn-contracts/docs/rewardcontrol.md)

### Structs

#### MarketState

```javascript
struct MarketState {
 uint224 index,
 uint32 block
}
```

### Contract Members

**Constants & Variables**

```javascript
mapping(bool => address[]) public allMarkets;
mapping(bool => mapping(address => bool)) public allMarketsIndex;
uint256 public alkRate;
mapping(bool => mapping(address => uint256)) public alkSpeeds;
mapping(bool => mapping(address => struct RewardControlStorage.MarketState)) public alkSupplyState;
mapping(bool => mapping(address => struct RewardControlStorage.MarketState)) public alkBorrowState;
mapping(bool => mapping(address => mapping(address => uint256))) public alkSupplierIndex;
mapping(bool => mapping(address => mapping(address => uint256))) public alkBorrowerIndex;
mapping(address => uint256) public alkAccrued;
bool public initializationDone;
address public owner;
address public newOwner;
contract AlkemiEarnVerified public alkemiEarnVerified;
contract AlkemiEarnPublic public alkemiEarnPublic;
address public alkAddress;
uint8 public MAXIMUM_NUMBER_OF_MARKETS;
```

### Functions


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.alkemi.network/earn-contracts/docs/rewardcontrolstorage.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
